def var bool as logical no-undo.
def var hdtt1 as handle.
def var bhdtt1 as handle.
def var hdtt2 as handle.
def var bhdtt2 as handle.

/* dtt1 */
create temp-table hdtt1.
hdtt1:add-new-field("legacy-F1", "character").
hdtt1:add-new-field("legacy-F2", "character").
hdtt1:add-new-field("legacy-F3", "integer").
hdtt1:add-new-field("legacy-F4", "integer").
hdtt1:add-new-field("days", "character", 5).
hdtt1:add-new-field("hours", "integer", 7).
hdtt1:temp-table-prepare("legacy-dynamic-table").
bhdtt1 = hdtt1:default-buffer-handle.

/* dtt2 */
create temp-table hdtt2.
hdtt2:add-new-field("days1", "character", 3).
hdtt2:temp-table-prepare("legacy-dynamic-table").
bhdtt2 = hdtt2:default-buffer-handle.


/* tt1 */
def temp-table tt1
field f1 as character
field f2 as character
field f3 as int
field f4 as int.

def buffer b1 for tt1.
def var hb1 as handle.
hb1 = buffer b1:handle.

create b1.
assign f1 = "aa"
       f2 = "ccc"
       f3 = 3
       f4 = 4.

/* tt2 */
def temp-table tt2
field days1 as character extent 3.

def buffer b2 for tt2.
def var hb2 as handle.
hb2 = buffer b2:handle.

create b2.
assign days1[1] = "aa"
       days1[2] = "bb"
       days1[3] = "cc".

def buffer p1 for person.
def var hp1 as handle.
hp1 = buffer p1:handle.

/*hp1:find-first("where schedule[1] <> ?").*/
find first p1 where schedule[1] <> ?.
DO TRANSACTION:
  assign p1.hours[2] = 14
         p1.hours[3] = 17
         p1.first-name = "Rod"
         p1.last-name = "Gaither"
         p1.emp-num = 101
         p1.schedule[1] = "Monday"
         p1.schedule[2] = "Tuesday"
         p1.schedule[3] = "Wednesday"
         p1.schedule[4] = "Thursday"
         p1.schedule[5] = "Friday".
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 1".
  bool = bhdtt1:buffer-copy(hb1, "", "legacy-f1,f1,Legacy-f2,b1.f2,F3,legacy-F3,f4,Legacy-F4").
  message "Result 1: " string(bool).
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 2".
  bool = hb1:buffer-copy(bhdtt1, "", "legacy-f1,f1,Legacy-f2,f2,F3,legacy-F3,b1.f4,Legacy-F4").
  message "Result 2: " string(bool).
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 3".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,schedule,days").
  message "Result 3: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 4".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,p1.last-name,emp-num,Legacy-F4,schedule[3],days[1]").
  message "Result 4: " string(bool).
/*  display bhdtt1:buffer-field("hours"):buffer-value(2).*/
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 5".
  bool = bhdtt1:buffer-copy(hp1, "hours", "legacy-f1,first-name,Legacy-f2,p1.last-name,emp-num,Legacy-F4").
  message "Result 5: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 6".
  bool = bhdtt1:buffer-copy(hp1, "bogusbuf.hours", "legacy-f1,first-name,Legacy-f2,p1.last-name,emp-num,Legacy-F4").
  message "Result 6: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 7".
  bool = bhdtt1:buffer-copy(hp1, "hours[3]", "legacy-f1,first-name,Legacy-f2,p1.last-name,emp-num,Legacy-F4").
  message "Result 7: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 8".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,bogusbuf.last-name,emp-num,Legacy-F4").
  message "Result 8: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 9".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,bogusbuf.Legacy-f2,last-name,emp-num,Legacy-F4").
  message "Result 9: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 10".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,not-in-dest,last-name,emp-num,Legacy-F4").
  message "Result 10: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 11".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,not-in-source,emp-num,Legacy-F4").
  message "Result 11: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 12".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,schedule[7],days[3]").
  message "Result 12: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 13".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,hours[7],hours[3]").
  message "Result 13: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 14".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,hours[7],hours[6]").
  message "Result 14: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 15".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,hours[3],hours").
  message "Result 15: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 16".
  bool = bhdtt1:buffer-copy(hp1).
  message "Result 16: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 17".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,hours[7],bogus.hours[3]").
  message "Result 17: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 17.1".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,hours[3],bogus.hours[3]").
  message "Result 17.1: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 17.2".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,junk.hours[3],hours[3]").
  message "Result 17.2: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 17.3".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,Legacy-f2,last-name,emp-num,Legacy-F4,junk.hours[3],bogus.hours[3]").
  message "Result 17.3: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 18".
  bool = bhdtt1:buffer-copy(hp1, "", "bogus.hours[7],hours[3]").
  message "Result 18: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 18.1".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[2],hours[3]").
  /*
  display
    bhdtt1:buffer-field("hours"):buffer-value(2)
    bhdtt1:buffer-field("hours"):buffer-value(3)
    with frame fr1.
  */
  message "Result 18.1: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 18.2".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[3],hours[2]").
  /*
  display
    bhdtt1:buffer-field("hours"):buffer-value(2)
    bhdtt1:buffer-field("hours"):buffer-value(3)
    with frame fr2.
  */
  message "Result 18.2: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 18.3".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[7],hours[3]").
  message "Result 18.3: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 18.4".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[3],hours[7]").
  message "Result 18.4: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19".
  bool = bhdtt1:buffer-copy(hp1, "", "@.*,!+").
  message "Result 19: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.1".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1,first-name,@.*,!+,Legacy-f2,last-name,emp-num,Legacy-F4").
  message "Result 19.1: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.2".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[[5],hours[3]").
  message "Result 19.2: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.3".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[5]]]]]],hours[3]").
  message "Result 19.3: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.4".
  bool = bhdtt1:buffer-copy(hp1, "", "p1.hours[-5],hours[3]").
  message "Result 19.4: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.5".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[a5],hours[3]").
  message "Result 19.5: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.6".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[5]]g,p1.hours[3],legacy-f1,first-name").
  message "Result 19.6: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.7".
  bool = bhdtt1:buffer-copy(hp1, "", "hours[5],p1.hours[3]]g,legacy-f1,first-name").
  message "Result 19.7: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 19.8".
  bool = bhdtt1:buffer-copy(hp1, "", "@.*,first-name").
  message "Result 19.8: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 20".
  bool = bhdtt1:buffer-copy(hp1, "", "legacy-f1[2],first-name").
  message "Result 20: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 21".
  bool = bhdtt1:buffer-copy(hp1, "", "@.*").
  message "Result 21: " string(bool).
  if bool then bhdtt1:buffer-release().
END.

bhdtt1:find-first().
hb1:find-first().
DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 22".
  bool = hb1:buffer-copy(bhdtt1, "", "days[2],f1").
  message "Result 22: " string(bool).
END.

bhdtt1:find-first().
DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 23".
  bool = bhdtt1:buffer-copy(bhdtt1, "", "days,days").
  message "Result 23: " string(bool).
END.

bhdtt1:find-first().
DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 24".
  bool = bhdtt2:buffer-copy(bhdtt1, "", "days1,days").
  message "Result 24: " string(bool).
END.

hb2:find-first().
DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 25".
  bool = bhdtt2:buffer-copy(hb2, "", "days1,days1").
  message "Result 25: " string(bool).
END.


bhdtt2:find-first().
DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 26".
  bool = bhdtt1:buffer-copy(bhdtt2, "", "days,days1").
  message "Result 26: " string(bool).
END.

bhdtt1:find-first().
hb1:find-first().
DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 27".
  bool = bhdtt1:buffer-copy(hb1, "", "f1,days[2]").
  message "Result 27: " string(bool).
END.

bhdtt1:find-first().
hb1:find-first().
DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 28".
  bool = bhdtt1:buffer-copy(hb1, "", "days[2],f1").
  message "Result 28: " string(bool).
END.

DO TRANSACTION ON ERROR UNDO, LEAVE:
  message "Test 29".
  bool = bhdtt2:buffer-copy(hb1, "", "schedule[3],days1[1]").
  message "Result 29: " string(bool).
END.


delete object hdtt1.

/*
display bhdtt1::legacy-f1 bhdtt1::legacy-f2 bhdtt1::legacy-f3 bhdtt1::legacy-f4
        bhdtt1:buffer-field("days"):buffer-value(1)
        bhdtt1:buffer-field("days"):buffer-value(2)
        bhdtt1:buffer-field("days"):buffer-value(3)
        bhdtt1:buffer-field("days"):buffer-value(4)
        bhdtt1:buffer-field("days"):buffer-value(5)
        bhdtt1:buffer-field("hours"):buffer-value(1)
        bhdtt1:buffer-field("hours"):buffer-value(2)
        bhdtt1:buffer-field("hours"):buffer-value(3)
        bhdtt1:buffer-field("hours"):buffer-value(4)
        bhdtt1:buffer-field("hours"):buffer-value(5)
        bhdtt1:buffer-field("hours"):buffer-value(6)
        bhdtt1:buffer-field("hours"):buffer-value(7)
  with frame fr1.
*/